/***************************************************************************
 *   fheroes2: https://github.com/ihhub/fheroes2                           *
 *   Copyright (C) 2024                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#pragma once

namespace fheroes2
{
    // Width of the rendered window border in pixels
    inline constexpr int borderWidthPx{ 16 };

    // Width of the rendered radar in pixels
    inline constexpr int radarWidthPx{ 144 };

    // Width of the rendered dialog shadow in pixels
    inline constexpr int shadowWidthPx{ 16 };

    // "Standard" width of the rendered dialog box in pixels
    inline constexpr int boxAreaWidthPx{ 244 };

    // Width of the rendered tile in pixels
    inline constexpr int tileWidthPx{ 32 };
}
